##!/usr/bin/env python
# -*- coding: utf-8 -*-

import gtk, gtk.glade, os, time, ConfigParser

class paramProjet:
    def __init__(self):
        print 'init paramProjet'
        self.config = ConfigParser.ConfigParser()
        self.config.read(os.path.join(os.environ['NOTECALC_DIR'],'config.ini'))
        self.paramProjet = {
            'title': '-',
            'date':time.localtime(),
            'author': os.environ['USER'],
            'description' : '-'
            }

    #remplissage
    def open(self):
        '''Remplissage des champs'''
        self.gui = gtk.glade.XML(os.path.join(os.environ['NOTECALC_DIR'],'gui','paramProjet.glade'))
        dictionnaire_temporaire = {}
        for iteration in dir(self.__class__):
            dictionnaire_temporaire[iteration]= getattr(self,iteration)
        self.gui.signal_autoconnect(dictionnaire_temporaire)

        self.gui.get_widget('title').set_text(self.paramProjet['title'])
        self.gui.get_widget('date').set_text(time.strftime(self.config.get('render','date'), self.paramProjet['date']))
        self.gui.get_widget('author').get_buffer().set_text(self.paramProjet['author'])
        self.gui.get_widget('description').get_buffer().set_text(self.paramProjet['description'])
        self.gui.get_widget('notAffichOnStart').set_active(self.config.getboolean('global','noparamproj'))

    #Quitter
    def on_paramProjet_destroy_event(self,event=None):
        return True

    def on_cancel_clicked(self,event):
        self.gui.get_widget('paramProjet').destroy()
        return self.on_paramProjet_destroy_event()

    #valider
    def on_validate_clicked(self,event):
        '''validation donc enregistrment des données dans le dico info'''
        try:
            self.paramProjet['date'] = time.strptime(self.gui.get_widget('date').get_text(),self.config.get('render','date'))
        except:
            #Saisie de date incorrecte
            self.paramProjet['date'] = time.localtime()
            boitedialogue = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING, # type
                    gtk.BUTTONS_OK_CANCEL, # boutons
                    _("Le format de le date est incorrect (il doit être sous la forme %s). Souaitez vous utilisé la date d'aujourd'hui ?"%self.config.get('render','date')))#Message

            if (boitedialogue.run() == gtk.RESPONSE_OK):
                pass
            else :
                boitedialogue.destroy()
                return

        self.paramProjet['title'] = self.gui.get_widget('title').get_text()
        buffer = self.gui.get_widget('description').get_buffer()
        (deb,fin) = buffer.get_bounds()
        self.paramProjet['description'] = buffer.get_text(deb,fin)
        buffer = self.gui.get_widget('author').get_buffer()
        (deb,fin) = buffer.get_bounds()
        self.paramProjet['author'] = buffer.get_text(deb,fin)

        self.gui.get_widget('paramProjet').destroy()
        return self.on_paramProjet_destroy_event()




    #date
    def on_selectDate_clicked(self,event):
        '''Afficher le calendrier'''
        print 'calendrier'
        self.gui.get_widget('winCalendar').show()


    def on_calendar_day_selected(self,calendar):
        '''Jours cliqué'''
        print 'day select :'
        (annee, mois, jour) = calendar.get_date()
        self.gui.get_widget('date').set_text(time.strftime(self.config.get('render','date'), (annee,mois,jour,0,0,0,0,0,0)))
        self.gui.get_widget('winCalendar').hide()

    def on_today_clicked(self,event):
        '''Insérer la date d'aujourd'hui'''
        self.gui.get_widget('date').set_text(time.strftime(self.config.get('render','date'),time.localtime()))
        self.gui.get_widget('winCalendar').hide()


    #ne pas afficher au démarrage
    def on_notAffichOnStart_toggled(self,checkButton):
        '''Affichage au démarrage'''
        if checkButton.get_active() :   self.config.set('global','noParamProj',1)
        else :                          self.config.set('global','noParamProj',0)
        self.config.write(open(os.path.join(os.environ['NOTECALC_DIR'],'config.ini'),'w'))



    def get(self):
        '''Retroune les paramètres du projet (écriture de fichier)'''
        return self.paramProjet

    def set(self,paramProjet):
        '''Introduire les paramètres du projet (chargement de fichier)'''
        self.paramProjet = paramProjet



if __name__ == '__main__':
    import notecalc
    exit()
